unit UStdFdEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons, FileCtrl;

type

  TFdInfo = record
    Name:string[20];
    DataType:string[8];
    Size:integer;
    Key:boolean;
    Null:boolean;
    UniCodeField:boolean;
  end;

  TfFdEditor = class(TForm)
    GroupBox1: TGroupBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button4: TButton;
    Button5: TButton;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    fdList: TListBox;
    Button7: TButton;
    Button6: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    UpDown1: TUpDown;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    RadioGroup1: TRadioGroup;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    GroupBox2: TGroupBox;
    RadioGroup2: TRadioGroup;
    FileListBox1: TFileListBox;
    Button8: TButton;
    Button9: TButton;
    Label7: TLabel;
    CheckBox2: TCheckBox;
    procedure Button3Click(Sender: TObject);
    procedure fdListClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    StartFieldCount,EndFieldCount:integer;
    UseSchemaFile,UseDataFile:boolean;
    UseFileName:string;
  end;

var
  fFdEditor: TfFdEditor;
  FdInfoList:array[0..199] of TFdInfo;

implementation

{$R *.dfm}

uses UAspFileDataSet;

procedure TfFdEditor.Button3Click(Sender: TObject);
begin
  self.Close;
end;

procedure TfFdEditor.fdListClick(Sender: TObject);
begin
  if(fdList.ItemIndex >= 0)then
    begin
      Edit1.Text := FdInfoList[fdList.ItemIndex].Name;
      Edit1.Hint := Edit1.Text;
      Edit2.Text := IntToStr(FdInfoList[fdList.ItemIndex].Size);
      CheckBox1.Checked := FdInfoList[fdList.ItemIndex].Key;
      CheckBox2.Checked := FdInfoList[fdList.ItemIndex].UniCodeField;
      case FdInfoList[fdList.ItemIndex].Null of
        TRUE : RadioGroup1.ItemIndex := 0;
        FALSE: RadioGroup1.ItemIndex := 1;
      end;//case...end!!
      Button5.Enabled := TRUE;
    end;//if...end!!
end;

procedure TfFdEditor.Button2Click(Sender: TObject);
var EditID:integer;
begin
  fdList.Items.Add(Edit1.Text);
  EditID := fdList.Items.Count-1;
  FdInfoList[EditID].Name := Edit1.Text;
  FdInfoList[EditID].Size := StrToIntDef(Edit2.Text,5);
  FdInfoList[EditID].Key  := CheckBox1.Checked;
  FdInfoList[EditID].UniCodeField := CheckBox2.Checked;
  if(RadioGroup1.ItemIndex = 0)then FdInfoList[EditID].Null := TRUE
  else FdInfoList[EditID].Null := FALSE;
  Panel2.Caption := ' Field Count : '+IntToStr(fdList.Items.Count);
  CheckBox1.Checked := FALSE;
  CheckBox2.Checked := FALSE;
  RadioGroup1.ItemIndex := 0;
end;

procedure TfFdEditor.Button5Click(Sender: TObject);
var LastItemNo,i:integer;
begin
  if(fdList.ItemIndex >= 0)then 
    begin
      LastItemNo := fdList.Items.Count-1;
      for i := fdList.ItemIndex+1 to fdList.Items.Count-1 do
        begin
          FdInfoList[i-1].Name         := FdInfoList[i].Name;
          FdInfoList[i-1].DataType     := FdInfoList[i].DataType;
          FdInfoList[i-1].Size         := FdInfoList[i].Size;
          FdInfoList[i-1].Key          := FdInfoList[i].Key;
          FdInfoList[i-1].Null         := FdInfoList[i].Null;
          FdInfoList[i-1].UniCodeField := FdInfoList[i].UniCodeField;
        end;//for...i...end!!
      //-------------------------------------------------------------
      FdInfoList[LastItemNo].Name         := '';
      FdInfoList[LastItemNo].DataType     := '';
      FdInfoList[LastItemNo].Size         := 0;
      FdInfoList[LastItemNo].Key          := FALSE;
      FdInfoList[LastItemNo].Null         := FALSE;
      FdInfoList[LastItemNo].UniCodeField := FALSE;
      //-------------------------------------------------------------
      fdList.Items.Delete(fdList.ItemIndex);
      Panel2.Caption := ' Field Count : '+IntToStr(fdList.Items.Count);
      Button5.Enabled := FALSE;
    end;//if...end!!
end;

procedure TfFdEditor.Button1Click(Sender: TObject);
var i:integer;
    fdStr:string;
    tempDS:TAspFileDataSet;
    dlg:TOpenDialog;
begin
  try
    dlg := TOpenDialog.Create(nil);
    dlg.Filter := 'Data File(*.XDB)|*.XDB';
    tempDS := TAspFileDataSet.Create(nil);
    tempDS.AccessUser := 'FieldEditor';
    if(dlg.Execute = TRUE)then
      begin
        tempDS.AccessFile := dlg.FileName;
        tempDS.Active := TRUE;
        if(tempDS.FieldCount > 0)then
          begin
            fdList.Items.Clear;
            for i := 0 to tempDS.FieldCount-1 do
              begin
                fdStr := tempDS.FieldName(i);
                fdList.Items.Add(fdStr);
                FdInfoList[i].Name := fdStr;
                FdInfoList[i].DataType := 'VARCHAR';
                FdInfoList[i].Size := tempDS.FieldDataSize(fdStr);
                FdInfoList[i].Key  := tempDS.IsKeyField(fdStr);
                FdInfoList[i].Null := not tempDS.RecDataSet.IsNotNullField[fdStr];
              end;//for...i...end!!
            Panel2.Caption := ' Field Count : '+IntToStr(tempDS.FieldCount);
          end;//if..end!!    
      end;//if...end!!
  finally
    dlg.Free;
    tempDS.Active := FALSE;
    tempDS.Free;
  end;//try...end!!
end;

procedure TfFdEditor.Button4Click(Sender: TObject);
var i:integer;
    fdStr:string;
    tempDS:TAspFileDataSet;
    dlg:TOpenDialog;
begin
  try
    dlg := TOpenDialog.Create(nil);
    dlg.Filter := 'Schema Data File(*.SFD)|*.SFD';
    tempDS := TAspFileDataSet.Create(nil);
    tempDS.AccessUser := 'FieldEditor';
    if(dlg.Execute = TRUE)then
      begin
        tempDS.RecDataSet.LoadSchema(dlg.FileName);
        if(tempDS.FieldCount > 0)then
          begin
            fdList.Items.Clear;
            for i := 0 to tempDS.FieldCount-1 do
              begin
                fdStr := tempDS.FieldName(i);
                fdList.Items.Add(fdStr);
                FdInfoList[i].Name := fdStr;
                FdInfoList[i].DataType := 'VARCHAR';
                FdInfoList[i].Size := tempDS.FieldDataSize(fdStr);
                FdInfoList[i].Key  := tempDS.IsKeyField(fdStr);
                FdInfoList[i].Null := not tempDS.RecDataSet.IsNotNullField[fdStr];
                FdInfoList[i].UniCodeField := not tempDS.RecDataSet.IsUniCodeField[fdStr];
              end;//for...i...end!!
            Panel2.Caption := ' Field Count : '+IntToStr(tempDS.FieldCount);
          end;//if..end!!    
      end;//if...end!!
  finally
    dlg.Free;
    tempDS.Free;
  end;//try...end!!
end;

procedure TfFdEditor.Button7Click(Sender: TObject);
var i:integer;
    tempDS:TAspFileDataSet;
    dlg:TSaveDialog;
begin
  try
    dlg := TSaveDialog.Create(nil);
    dlg.Filter := 'Schema Data File(*.SFD)|*.SFD';
    tempDS := TAspFileDataSet.Create(nil);
    tempDS.AccessUser := 'FieldEditor';
    for i := 0 to fdList.Items.Count-1 do
      begin
        tempDS.AddNewField( FdInfoList[i].Name
                           ,FdInfoList[i].Size
                           ,FdInfoList[i].Key
                           ,FdInfoList[i].Null
                           ,FdInfoList[i].UniCodeField
                           ,FALSE,nil,'','','');
      end;//for...i...end!!
    //--------------------------------------------------------------
    //ShowMessage('Field Count :'+IntToStr(tempDS.FieldCount)+' !!');
    //--------------------------------------------------------------
    if(tempDS.FieldCount > 0)then
      begin
        if(dlg.Execute = TRUE)then
          begin
            //ShowMessage('FileName :'+dlg.FileName);
            tempDS.SaveSchema(dlg.FileName);
          end;//if...end!!
      end;//if...end!!
     //--------------------------------------------------------------
  finally
    dlg.Free;
    tempDS.Free;
  end;//try...end!!
end;

procedure TfFdEditor.SpeedButton1Click(Sender: TObject);
var tmpfd:TFdinfo;
    str:string;
begin
  if(fdList.ItemIndex > 0)then
    begin
      str := fdList.Items[fdList.ItemIndex-1];
      tmpfd.Name := FdInfoList[fdList.ItemIndex-1].Name;
      tmpfd.Size := FdInfoList[fdList.ItemIndex-1].Size;
      tmpfd.Key  := FdInfoList[fdList.ItemIndex-1].Key;
      tmpfd.Null := FdInfoList[fdList.ItemIndex-1].Null;
      //------------------------------------------------
      fdList.Items[fdList.ItemIndex-1] := fdList.Items[fdList.ItemIndex];
      FdInfoList[fdList.ItemIndex-1].Name := FdInfoList[fdList.ItemIndex].Name;
      FdInfoList[fdList.ItemIndex-1].Size := FdInfoList[fdList.ItemIndex].Size;
      FdInfoList[fdList.ItemIndex-1].Key  := FdInfoList[fdList.ItemIndex].Key;
      FdInfoList[fdList.ItemIndex-1].Null := FdInfoList[fdList.ItemIndex].Null;
      //-----------------------------------------------------------------------
      fdList.Items[fdList.ItemIndex] := str;
      FdInfoList[fdList.ItemIndex].Name := tmpfd.Name;
      FdInfoList[fdList.ItemIndex].Size := tmpfd.Size;
      FdInfoList[fdList.ItemIndex].Key  := tmpfd.Key;
      FdInfoList[fdList.ItemIndex].Null := tmpfd.Null;
      fdList.ItemIndex := fdList.ItemIndex-1;
    end;//if...end!!
end;

procedure TfFdEditor.SpeedButton2Click(Sender: TObject);
var tmpfd:TFdinfo;
    str:string;
begin
  if(fdList.ItemIndex = fdList.Items.Count-1)then
    Exit;
  if(fdList.ItemIndex >= 0)then
    begin
      str := fdList.Items[fdList.ItemIndex+1];
      tmpfd.Name := FdInfoList[fdList.ItemIndex+1].Name;
      tmpfd.Size := FdInfoList[fdList.ItemIndex+1].Size;
      tmpfd.Key  := FdInfoList[fdList.ItemIndex+1].Key;
      tmpfd.Null := FdInfoList[fdList.ItemIndex+1].Null;
      //++++++++++++++++++++++++++++++++++++++++++++++++
      fdList.Items[fdList.ItemIndex+1] := fdList.Items[fdList.ItemIndex];
      FdInfoList[fdList.ItemIndex+1].Name := FdInfoList[fdList.ItemIndex].Name;
      FdInfoList[fdList.ItemIndex+1].Size := FdInfoList[fdList.ItemIndex].Size;
      FdInfoList[fdList.ItemIndex+1].Key  := FdInfoList[fdList.ItemIndex].Key;
      FdInfoList[fdList.ItemIndex+1].Null := FdInfoList[fdList.ItemIndex].Null;
      //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      fdList.Items[fdList.ItemIndex] := str;
      FdInfoList[fdList.ItemIndex].Name := tmpfd.Name;
      FdInfoList[fdList.ItemIndex].Size := tmpfd.Size;
      FdInfoList[fdList.ItemIndex].Key  := tmpfd.Key;
      FdInfoList[fdList.ItemIndex].Null := tmpfd.Null;
      fdList.ItemIndex := fdList.ItemIndex+1;
    end;//if...end!!
end;

procedure TfFdEditor.Button6Click(Sender: TObject);
var i,j:integer;
    tempDS:TAspFileDataSet;
    dlg:TSaveDialog;
    str:string;
begin
  try
    dlg := TSaveDialog.Create(nil);
    dlg.Filter := 'Data File(*.XDB)|*.XDB';
    tempDS := TAspFileDataSet.Create(nil);
    tempDS.AccessUser := 'FieldEditor';
    for i := 0 to fdList.Items.Count-1 do
      begin
        tempDS.AddNewField( FdInfoList[i].Name
                           ,FdInfoList[i].Size
                           ,FdInfoList[i].Key
                           ,FdInfoList[i].Null
                           ,FdInfoList[i].UniCodeField
                           ,FALSE,nil,'','','');
      end;//for...i...end!!
    //--------------------------------------------------------------
    //ShowMessage('Field Count :'+IntToStr(tempDS.FieldCount)+' !!');
    //--------------------------------------------------------------
    if(tempDS.FieldCount > 0)then
      begin
        if(dlg.Execute = TRUE)then
          begin
            //ShowMessage('FileName :'+dlg.FileName);
            tempDS.AccessFile := dlg.FileName;
            tempDS.Active := TRUE;
            tempDS.Insert;
            for j := 0 to tempDS.FieldCount-1 do
              begin
                str := tempDS.FieldName(j);
                tempDS.FieldByName(str).AsString := '*';
              end;//for...j...end!!
            tempDS.Post;
            ShowMessage('Creating ''*.XDB'' file is success!!');
          end;//if...end!!
      end;//if...end!!
     //--------------------------------------------------------------
  finally
    tempDS.Active := FALSE;
    dlg.Free;
    tempDS.Free;
  end;//try...end!!
end;

procedure TfFdEditor.RadioGroup2Click(Sender: TObject);
begin
  if(RadioGroup2.ItemIndex = 0)then FileListBox1.Mask := '*.XDB'
  else FileListBox1.Mask := '*.SFD';
end;

procedure TfFdEditor.FileListBox1Click(Sender: TObject);
var i:integer;
    fdStr:string;
    tempDS:TAspFileDataSet;
begin
  if(FileListBox1.ItemIndex >= 0)then
  try
    tempDS := TAspFileDataSet.Create(nil);
    tempDS.AccessUser := 'FieldEditor';
    tempDS.AccessFile := '';
    tempDS.SchemaFileName := '';
    if(RadioGroup2.ItemIndex = 0)then
      tempDS.AccessFile := FileListBox1.FileName
    else tempDS.SchemaFileName := FileListBox1.FileName;
    tempDS.Active := TRUE;
    if(tempDS.FieldCount > 0)then
      begin
        fdList.Items.Clear;
        for i := 0 to tempDS.FieldCount-1 do
          begin
            fdStr := tempDS.FieldName(i);
            fdList.Items.Add(fdStr);
            FdInfoList[i].Name := fdStr;
            FdInfoList[i].DataType := 'VARCHAR';
            FdInfoList[i].Size := tempDS.FieldDataSize(fdStr);
            FdInfoList[i].Key  := tempDS.IsKeyField(fdStr);
            FdInfoList[i].Null := not tempDS.RecDataSet.IsNotNullField[fdStr];
            FdInfoList[i].UniCodeField := tempDS.RecDataSet.IsUniCodeField[fdStr];
          end;//for...i...end!!
        Panel2.Caption := ' Field Count : '+IntToStr(tempDS.FieldCount);
      end;//if..end!!
  finally
    tempDS.Active := FALSE;
    tempDS.Free;
  end;//try...end!!
end;

procedure TfFdEditor.Button8Click(Sender: TObject);
begin
  if(FileListBox1.ItemIndex >= 0)then
    begin
      UseFileName := FileListBox1.FileName;
      if(RadioGroup2.ItemIndex = 0)then
        begin
          UseSchemaFile := FALSE;
          UseDataFile   := TRUE;
        end//if...end!!
      else
        begin
          UseSchemaFile := TRUE;
          UseDataFile   := FALSE;
        end;//else...end!!
      Button3.Click;  
    end;//if...end!!        
end;

procedure TfFdEditor.Button9Click(Sender: TObject);
var EditID:integer;
begin
  if(trim(Edit1.Text) = '')then Exit;
  EditID := fdList.Items.IndexOf(Edit1.Hint);
  if(EditID >= 0)then //Update !!
    begin
      fdList.Items[EditID]    := Edit1.Text;
      FdInfoList[EditID].Name := Edit1.Text;
      FdInfoList[EditID].Size := StrToIntDef(Edit2.Text,5);
      FdInfoList[EditID].Key  := CheckBox1.Checked;
      FdInfoList[EditID].UniCodeField := CheckBox2.Checked;
      if(RadioGroup1.ItemIndex = 0)then FdInfoList[EditID].Null := TRUE
      else FdInfoList[EditID].Null := FALSE;
    end//if...end!!
end;

procedure TfFdEditor.CheckBox1Click(Sender: TObject);
begin
  if(CheckBox1.Checked = FALSE)then
    RadioGroup1.ItemIndex := 0
  else RadioGroup1.ItemIndex := 1;  
end;

end.
